//
//  UPNP-SSDP.h
//  SSDPtest
//
//  Created by Michael Rothwell on Tue Mar 30 2004.
//  Copyright (c) 2004 Michael Rothwell. All rights reserved.
//
//  Sends notification "UPNP_SSDP:RawData" on every read
//  Sends notification "UPNP_SSDP:FilteredRawData" when data read matches a registered URN
//
//  $Id: UPNP_SSDP.h,v 1.2 2004/04/02 12:13:23 rothwell Exp $
//


#import <Foundation/Foundation.h>


@interface UPNP_SSDP : NSObject {

    int fileDescriptor;

    CFSocketRef theSocket;
    CFRunLoopSourceRef theSource;
    
    NSMutableDictionary *URNs;
    NSMutableDictionary *Devices;
    NSMutableDictionary *Mapper;
    
    NSCharacterSet *ws;
    NSCharacterSet *nan;
}

// returns singleton
-(id)init;

// returns the file descriptor used for listening to SSDP traffic
-(int)fileDescriptor;

// listen for a particular urn, e.g. -> urn:replaytv-com:device:ReplayDevice:1
-(void)registerURN:(NSString *)urn;

// stop listening for a particular urn
-(void)unRegisterURN:(NSString *)urn;

// send SSDP discovery request for registered urns
-(void)send_probe;

@end
